var path = require('path');
var fs = require('fs');

module.exports={
    //This method search for file recursively from given folder and up.
    findFileRecursively: function (filename, workspacePath, lookInParentFolders, logger) {
        var searchedPaths = {};
        do {
            var filePath = path.resolve(workspacePath, filename);
            // Already searched at
            if (searchedPaths[filePath])
                return null;
            logger.debug('Looking for ' + filename + ' at ' + filePath);

            // Mark current path as visited.
            searchedPaths[filePath] = true;
            try {
                // Check if file exist and not directory
                var f = fs.statSync(filePath);
                if (f.isFile()) {
                    logger.debug("found file: " + filename + ". in: " + workspacePath);
                    return filePath;
                }else{
                    workspacePath = levelUp(workspacePath, filename, logger);
                }
            } catch (e) {
                workspacePath = levelUp(workspacePath, filename, logger);
            }
            if (!lookInParentFolders){
                logger.debug("should not search in parent directories, breaking out.")
                break;
            }
        } while (workspacePath.length > 1);
        logger.info(filename + ' not found');
        return null;
    }
};

function levelUp(workspacePath, filename, logger) {
    logger.debug("file: " + filename + ". not found in: " + workspacePath + ". searching in parent directory");
    workspacePath = workspacePath + '/..';
    return workspacePath;
}