var needle = require("needle");
var fs = require("fs");

needle.defaults({open_timeout: 120000});

function SlNeedle(token) {
    this.token = token;
}

SlNeedle.prototype.trySetToken = function trySetToken(options) {
    if (this.token) {
        if (!options.headers) {
            options.headers = {}
        }
        options.headers["authorization"] = "Bearer " + this.token;
    }
};

["head", "get"].forEach(function(method) {
    SlNeedle.prototype[method] = function(uri, options, callback) {
        if (typeof options == 'function') {
            callback = options;
            options = {};
        }
        if (!options) {
            options = {};
        }
        this.trySetToken(options);
        return needle[method](uri, options, callback);
    }
});

["post", "put", "delete"].forEach(function(method) {
    SlNeedle.prototype[method] = function(uri, data, options, callback) {
        if (typeof options == 'function') {
            callback = options;
            options = {};
        }
        if (!options) {
            options = {};
        }
        this.trySetToken(options);
        return needle[method](uri, data, options, callback);
    }
});

SlNeedle.prototype.request = function(method, uri, data, opts, callback) {
    if (typeof opts == 'function') {
        callback = opts;
        opts = {};
    }
    if (!opts) {
        opts = {};
    }
    this.trySetToken(opts);
    return needle.request(method, uri, data, opts, callback);
};

module.exports.SlNeedle = SlNeedle;
